sidebarNodes={"extras":[{"id":"api-reference","title":"API Reference","group":"","headers":[{"id":"Modules","anchor":"modules"},{"id":"Exceptions","anchor":"exceptions"}]},{"id":"compatibility-and-deprecations","title":"Compatibility and Deprecations","group":"","headers":[{"id":"Compatibility between non-major Elixir versions","anchor":"compatibility-between-non-major-elixir-versions"},{"id":"Compatibility between Elixir and Erlang/OTP","anchor":"compatibility-between-elixir-and-erlang-otp"},{"id":"Deprecations","anchor":"deprecations"}]},{"id":"guards","title":"Guards","group":"","headers":[{"id":"List of allowed expressions","anchor":"list-of-allowed-expressions"},{"id":"Why guards","anchor":"why-guards"},{"id":"Where guards can be used","anchor":"where-guards-can-be-used"},{"id":"Failing guards","anchor":"failing-guards"},{"id":"Defining custom guard expressions","anchor":"defining-custom-guard-expressions"},{"id":"Multiple guards in the same clause","anchor":"multiple-guards-in-the-same-clause"}]},{"id":"library-guidelines","title":"Library Guidelines","group":"","headers":[{"id":"Getting started","anchor":"getting-started"},{"id":"Publishing","anchor":"publishing"},{"id":"Anti-patterns","anchor":"anti-patterns"}]},{"id":"naming-conventions","title":"Naming Conventions","group":"","headers":[{"id":"Casing","anchor":"casing"},{"id":"Underscore (_foo)","anchor":"underscore-_foo"},{"id":"Trailing bang (foo!)","anchor":"trailing-bang-foo"},{"id":"Trailing question mark (foo?)","anchor":"trailing-question-mark-foo"},{"id":"is_ prefix (is_foo)","anchor":"is_-prefix-is_foo"},{"id":"Special names","anchor":"special-names"}]},{"id":"operators","title":"Operators","group":"","headers":[{"id":"Operator precedence and associativity","anchor":"operator-precedence-and-associativity"},{"id":"Comparison operators","anchor":"comparison-operators"},{"id":"Custom and overridden operators","anchor":"custom-and-overridden-operators"}]},{"id":"syntax-reference","title":"Syntax reference","group":"","headers":[{"id":"Reserved words","anchor":"reserved-words"},{"id":"Data types","anchor":"data-types"},{"id":"Expressions","anchor":"expressions"},{"id":"The Elixir AST","anchor":"the-elixir-ast"},{"id":"Syntactic sugar","anchor":"syntactic-sugar"},{"id":"Summary","anchor":"summary"}]},{"id":"typespecs","title":"Typespecs","group":"","headers":[{"id":"A simple example","anchor":"a-simple-example"},{"id":"Types and their syntax","anchor":"types-and-their-syntax"},{"id":"Defining a specification","anchor":"defining-a-specification"},{"id":"Behaviours","anchor":"behaviours"},{"id":"The string() type","anchor":"the-string-type"}]},{"id":"unicode-syntax","title":"Unicode Syntax","group":"","headers":[{"id":"R1. Default Identifiers","anchor":"r1-default-identifiers"},{"id":"R3. Pattern_White_Space and Pattern_Syntax Characters","anchor":"r3-pattern_white_space-and-pattern_syntax-characters"},{"id":"R6. Filtered Normalized Identifiers","anchor":"r6-filtered-normalized-identifiers"}]},{"id":"writing-documentation","title":"Writing Documentation","group":"","headers":[{"id":"Markdown","anchor":"markdown"},{"id":"Module Attributes","anchor":"module-attributes"},{"id":"Function Arguments","anchor":"function-arguments"},{"id":"Documentation metadata","anchor":"documentation-metadata"},{"id":"Recommendations","anchor":"recommendations"},{"id":"Doctests","anchor":"doctests"},{"id":"Documentation != Code comments","anchor":"documentation-code-comments"},{"id":"Hiding Internal Modules and Functions","anchor":"hiding-internal-modules-and-functions"},{"id":"Code.fetch_docs/1","anchor":"code-fetch_docs-1"}]}],"exceptions":[{"id":"ArgumentError","title":"ArgumentError","group":""},{"id":"ArithmeticError","title":"ArithmeticError","group":""},{"id":"BadArityError","title":"BadArityError","group":""},{"id":"BadBooleanError","title":"BadBooleanError","group":""},{"id":"BadFunctionError","title":"BadFunctionError","group":""},{"id":"BadMapError","title":"BadMapError","group":""},{"id":"BadStructError","title":"BadStructError","group":""},{"id":"CaseClauseError","title":"CaseClauseError","group":""},{"id":"Code.LoadError","title":"Code.LoadError","group":""},{"id":"CompileError","title":"CompileError","group":""},{"id":"CondClauseError","title":"CondClauseError","group":""},{"id":"Enum.EmptyError","title":"Enum.EmptyError","group":""},{"id":"Enum.OutOfBoundsError","title":"Enum.OutOfBoundsError","group":""},{"id":"ErlangError","title":"ErlangError","group":""},{"id":"File.CopyError","title":"File.CopyError","group":""},{"id":"File.Error","title":"File.Error","group":""},{"id":"File.LinkError","title":"File.LinkError","group":""},{"id":"File.RenameError","title":"File.RenameError","group":""},{"id":"FunctionClauseError","title":"FunctionClauseError","group":""},{"id":"IO.StreamError","title":"IO.StreamError","group":""},{"id":"Inspect.Error","title":"Inspect.Error","group":""},{"id":"KeyError","title":"KeyError","group":""},{"id":"MatchError","title":"MatchError","group":""},{"id":"OptionParser.ParseError","title":"OptionParser.ParseError","group":""},{"id":"Protocol.UndefinedError","title":"Protocol.UndefinedError","group":""},{"id":"Regex.CompileError","title":"Regex.CompileError","group":""},{"id":"RuntimeError","title":"RuntimeError","group":""},{"id":"SyntaxError","title":"SyntaxError","group":""},{"id":"SystemLimitError","title":"SystemLimitError","group":""},{"id":"TokenMissingError","title":"TokenMissingError","group":""},{"id":"TryClauseError","title":"TryClauseError","group":""},{"id":"UndefinedFunctionError","title":"UndefinedFunctionError","group":""},{"id":"UnicodeConversionError","title":"UnicodeConversionError","group":""},{"id":"Version.InvalidRequirementError","title":"Version.InvalidRequirementError","group":""},{"id":"Version.InvalidVersionError","title":"Version.InvalidVersionError","group":""},{"id":"WithClauseError","title":"WithClauseError","group":""}],"modules":[{"id":"Kernel","title":"Kernel","group":"","nodeGroups":[{"key":"guards","name":"Guards","nodes":[{"id":"!=/2","anchor":"!=/2"},{"id":"!==/2","anchor":"!==/2"},{"id":"*/2","anchor":"*/2"},{"id":"+/1","anchor":"+/1"},{"id":"+/2","anchor":"+/2"},{"id":"-/1","anchor":"-/1"},{"id":"-/2","anchor":"-/2"},{"id":"//2","anchor":"//2"},{"id":"</2","anchor":"%3C/2"},{"id":"<=/2","anchor":"%3C=/2"},{"id":"==/2","anchor":"==/2"},{"id":"===/2","anchor":"===/2"},{"id":">/2","anchor":"%3E/2"},{"id":">=/2","anchor":"%3E=/2"},{"id":"abs/1","anchor":"abs/1"},{"id":"and/2","anchor":"and/2"},{"id":"binary_part/3","anchor":"binary_part/3"},{"id":"bit_size/1","anchor":"bit_size/1"},{"id":"byte_size/1","anchor":"byte_size/1"},{"id":"ceil/1","anchor":"ceil/1"},{"id":"div/2","anchor":"div/2"},{"id":"elem/2","anchor":"elem/2"},{"id":"floor/1","anchor":"floor/1"},{"id":"hd/1","anchor":"hd/1"},{"id":"in/2","anchor":"in/2"},{"id":"is_atom/1","anchor":"is_atom/1"},{"id":"is_binary/1","anchor":"is_binary/1"},{"id":"is_bitstring/1","anchor":"is_bitstring/1"},{"id":"is_boolean/1","anchor":"is_boolean/1"},{"id":"is_float/1","anchor":"is_float/1"},{"id":"is_function/1","anchor":"is_function/1"},{"id":"is_function/2","anchor":"is_function/2"},{"id":"is_integer/1","anchor":"is_integer/1"},{"id":"is_list/1","anchor":"is_list/1"},{"id":"is_map/1","anchor":"is_map/1"},{"id":"is_nil/1","anchor":"is_nil/1"},{"id":"is_number/1","anchor":"is_number/1"},{"id":"is_pid/1","anchor":"is_pid/1"},{"id":"is_port/1","anchor":"is_port/1"},{"id":"is_reference/1","anchor":"is_reference/1"},{"id":"is_tuple/1","anchor":"is_tuple/1"},{"id":"length/1","anchor":"length/1"},{"id":"map_size/1","anchor":"map_size/1"},{"id":"node/0","anchor":"node/0"},{"id":"node/1","anchor":"node/1"},{"id":"not/1","anchor":"not/1"},{"id":"or/2","anchor":"or/2"},{"id":"rem/2","anchor":"rem/2"},{"id":"round/1","anchor":"round/1"},{"id":"self/0","anchor":"self/0"},{"id":"tl/1","anchor":"tl/1"},{"id":"trunc/1","anchor":"trunc/1"},{"id":"tuple_size/1","anchor":"tuple_size/1"}]},{"key":"functions","name":"Functions","nodes":[{"id":"!/1","anchor":"!/1"},{"id":"&&/2","anchor":"&&/2"},{"id":"++/2","anchor":"++/2"},{"id":"--/2","anchor":"--/2"},{"id":"../2","anchor":"../2"},{"id":"<>/2","anchor":"%3C%3E/2"},{"id":"=~/2","anchor":"=~/2"},{"id":"@/1","anchor":"@/1"},{"id":"alias!/1","anchor":"alias!/1"},{"id":"apply/2","anchor":"apply/2"},{"id":"apply/3","anchor":"apply/3"},{"id":"binding/1","anchor":"binding/1"},{"id":"def/2","anchor":"def/2"},{"id":"defdelegate/2","anchor":"defdelegate/2"},{"id":"defexception/1","anchor":"defexception/1"},{"id":"defguard/1","anchor":"defguard/1"},{"id":"defguardp/1","anchor":"defguardp/1"},{"id":"defimpl/3","anchor":"defimpl/3"},{"id":"defmacro/2","anchor":"defmacro/2"},{"id":"defmacrop/2","anchor":"defmacrop/2"},{"id":"defmodule/2","anchor":"defmodule/2"},{"id":"defoverridable/1","anchor":"defoverridable/1"},{"id":"defp/2","anchor":"defp/2"},{"id":"defprotocol/2","anchor":"defprotocol/2"},{"id":"defstruct/1","anchor":"defstruct/1"},{"id":"destructure/2","anchor":"destructure/2"},{"id":"exit/1","anchor":"exit/1"},{"id":"function_exported?/3","anchor":"function_exported?/3"},{"id":"get_and_update_in/2","anchor":"get_and_update_in/2"},{"id":"get_and_update_in/3","anchor":"get_and_update_in/3"},{"id":"get_in/2","anchor":"get_in/2"},{"id":"if/2","anchor":"if/2"},{"id":"inspect/2","anchor":"inspect/2"},{"id":"macro_exported?/3","anchor":"macro_exported?/3"},{"id":"make_ref/0","anchor":"make_ref/0"},{"id":"match?/2","anchor":"match?/2"},{"id":"max/2","anchor":"max/2"},{"id":"min/2","anchor":"min/2"},{"id":"pop_in/1","anchor":"pop_in/1"},{"id":"pop_in/2","anchor":"pop_in/2"},{"id":"put_elem/3","anchor":"put_elem/3"},{"id":"put_in/2","anchor":"put_in/2"},{"id":"put_in/3","anchor":"put_in/3"},{"id":"raise/1","anchor":"raise/1"},{"id":"raise/2","anchor":"raise/2"},{"id":"reraise/2","anchor":"reraise/2"},{"id":"reraise/3","anchor":"reraise/3"},{"id":"send/2","anchor":"send/2"},{"id":"sigil_C/2","anchor":"sigil_C/2"},{"id":"sigil_D/2","anchor":"sigil_D/2"},{"id":"sigil_N/2","anchor":"sigil_N/2"},{"id":"sigil_R/2","anchor":"sigil_R/2"},{"id":"sigil_S/2","anchor":"sigil_S/2"},{"id":"sigil_T/2","anchor":"sigil_T/2"},{"id":"sigil_U/2","anchor":"sigil_U/2"},{"id":"sigil_W/2","anchor":"sigil_W/2"},{"id":"sigil_c/2","anchor":"sigil_c/2"},{"id":"sigil_r/2","anchor":"sigil_r/2"},{"id":"sigil_s/2","anchor":"sigil_s/2"},{"id":"sigil_w/2","anchor":"sigil_w/2"},{"id":"spawn/1","anchor":"spawn/1"},{"id":"spawn/3","anchor":"spawn/3"},{"id":"spawn_link/1","anchor":"spawn_link/1"},{"id":"spawn_link/3","anchor":"spawn_link/3"},{"id":"spawn_monitor/1","anchor":"spawn_monitor/1"},{"id":"spawn_monitor/3","anchor":"spawn_monitor/3"},{"id":"struct/2","anchor":"struct/2"},{"id":"struct!/2","anchor":"struct!/2"},{"id":"throw/1","anchor":"throw/1"},{"id":"to_charlist/1","anchor":"to_charlist/1"},{"id":"to_string/1","anchor":"to_string/1"},{"id":"unless/2","anchor":"unless/2"},{"id":"update_in/2","anchor":"update_in/2"},{"id":"update_in/3","anchor":"update_in/3"},{"id":"use/2","anchor":"use/2"},{"id":"var!/2","anchor":"var!/2"},{"id":"|>/2","anchor":"%7C%3E/2"},{"id":"||/2","anchor":"%7C%7C/2"}]}]},{"id":"Kernel.SpecialForms","title":"Kernel.SpecialForms","group":"","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"%/2","anchor":"%25/2"},{"id":"%{}/1","anchor":"%25%7B%7D/1"},{"id":"&/1","anchor":"&/1"},{"id":"./2","anchor":"./2"},{"id":"::/2","anchor":"::/2"},{"id":"<<>>/1","anchor":"%3C%3C%3E%3E/1"},{"id":"=/2","anchor":"=/2"},{"id":"^/1","anchor":"%5E/1"},{"id":"__CALLER__/0","anchor":"__CALLER__/0"},{"id":"__DIR__/0","anchor":"__DIR__/0"},{"id":"__ENV__/0","anchor":"__ENV__/0"},{"id":"__MODULE__/0","anchor":"__MODULE__/0"},{"id":"__STACKTRACE__/0","anchor":"__STACKTRACE__/0"},{"id":"__aliases__/1","anchor":"__aliases__/1"},{"id":"__block__/1","anchor":"__block__/1"},{"id":"alias/2","anchor":"alias/2"},{"id":"case/2","anchor":"case/2"},{"id":"cond/1","anchor":"cond/1"},{"id":"fn/1","anchor":"fn/1"},{"id":"for/1","anchor":"for/1"},{"id":"import/2","anchor":"import/2"},{"id":"quote/2","anchor":"quote/2"},{"id":"receive/1","anchor":"receive/1"},{"id":"require/2","anchor":"require/2"},{"id":"super/1","anchor":"super/1"},{"id":"try/1","anchor":"try/1"},{"id":"unquote/1","anchor":"unquote/1"},{"id":"unquote_splicing/1","anchor":"unquote_splicing/1"},{"id":"with/1","anchor":"with/1"},{"id":"{}/1","anchor":"%7B%7D/1"}]}]},{"id":"Atom","title":"Atom","group":"Basic Types","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"to_charlist/1","anchor":"to_charlist/1"},{"id":"to_string/1","anchor":"to_string/1"}]}]},{"id":"Base","title":"Base","group":"Basic Types","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"decode16/2","anchor":"decode16/2"},{"id":"decode16!/2","anchor":"decode16!/2"},{"id":"decode32/2","anchor":"decode32/2"},{"id":"decode32!/2","anchor":"decode32!/2"},{"id":"decode64/2","anchor":"decode64/2"},{"id":"decode64!/2","anchor":"decode64!/2"},{"id":"encode16/2","anchor":"encode16/2"},{"id":"encode32/2","anchor":"encode32/2"},{"id":"encode64/2","anchor":"encode64/2"},{"id":"hex_decode32/2","anchor":"hex_decode32/2"},{"id":"hex_decode32!/2","anchor":"hex_decode32!/2"},{"id":"hex_encode32/2","anchor":"hex_encode32/2"},{"id":"url_decode64/2","anchor":"url_decode64/2"},{"id":"url_decode64!/2","anchor":"url_decode64!/2"},{"id":"url_encode64/2","anchor":"url_encode64/2"}]}]},{"id":"Bitwise","title":"Bitwise","group":"Basic Types","nodeGroups":[{"key":"guards","name":"Guards","nodes":[{"id":"&&&/2","anchor":"&&&/2"},{"id":"<<</2","anchor":"%3C%3C%3C/2"},{"id":">>>/2","anchor":"%3E%3E%3E/2"},{"id":"^^^/2","anchor":"%5E%5E%5E/2"},{"id":"band/2","anchor":"band/2"},{"id":"bnot/1","anchor":"bnot/1"},{"id":"bor/2","anchor":"bor/2"},{"id":"bsl/2","anchor":"bsl/2"},{"id":"bsr/2","anchor":"bsr/2"},{"id":"bxor/2","anchor":"bxor/2"},{"id":"|||/2","anchor":"%7C%7C%7C/2"},{"id":"~~~/1","anchor":"~~~/1"}]}]},{"id":"Date","title":"Date","group":"Basic Types","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"add/2","anchor":"add/2"},{"id":"compare/2","anchor":"compare/2"},{"id":"convert/2","anchor":"convert/2"},{"id":"convert!/2","anchor":"convert!/2"},{"id":"day_of_era/1","anchor":"day_of_era/1"},{"id":"day_of_week/1","anchor":"day_of_week/1"},{"id":"day_of_year/1","anchor":"day_of_year/1"},{"id":"days_in_month/1","anchor":"days_in_month/1"},{"id":"diff/2","anchor":"diff/2"},{"id":"from_erl/2","anchor":"from_erl/2"},{"id":"from_erl!/2","anchor":"from_erl!/2"},{"id":"from_iso8601/2","anchor":"from_iso8601/2"},{"id":"from_iso8601!/2","anchor":"from_iso8601!/2"},{"id":"leap_year?/1","anchor":"leap_year?/1"},{"id":"months_in_year/1","anchor":"months_in_year/1"},{"id":"new/4","anchor":"new/4"},{"id":"quarter_of_year/1","anchor":"quarter_of_year/1"},{"id":"range/2","anchor":"range/2"},{"id":"to_erl/1","anchor":"to_erl/1"},{"id":"to_iso8601/2","anchor":"to_iso8601/2"},{"id":"to_string/1","anchor":"to_string/1"},{"id":"utc_today/1","anchor":"utc_today/1"},{"id":"year_of_era/1","anchor":"year_of_era/1"}]}]},{"id":"DateTime","title":"DateTime","group":"Basic Types","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"add/4","anchor":"add/4"},{"id":"compare/2","anchor":"compare/2"},{"id":"convert/2","anchor":"convert/2"},{"id":"convert!/2","anchor":"convert!/2"},{"id":"diff/3","anchor":"diff/3"},{"id":"from_iso8601/2","anchor":"from_iso8601/2"},{"id":"from_naive/3","anchor":"from_naive/3"},{"id":"from_naive!/3","anchor":"from_naive!/3"},{"id":"from_unix/3","anchor":"from_unix/3"},{"id":"from_unix!/3","anchor":"from_unix!/3"},{"id":"now/2","anchor":"now/2"},{"id":"shift_zone/3","anchor":"shift_zone/3"},{"id":"to_date/1","anchor":"to_date/1"},{"id":"to_iso8601/2","anchor":"to_iso8601/2"},{"id":"to_naive/1","anchor":"to_naive/1"},{"id":"to_string/1","anchor":"to_string/1"},{"id":"to_time/1","anchor":"to_time/1"},{"id":"to_unix/2","anchor":"to_unix/2"},{"id":"truncate/2","anchor":"truncate/2"},{"id":"utc_now/1","anchor":"utc_now/1"}]}]},{"id":"Exception","title":"Exception","group":"Basic Types","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"kind/0","anchor":"t:kind/0"},{"id":"stacktrace/0","anchor":"t:stacktrace/0"},{"id":"stacktrace_entry/0","anchor":"t:stacktrace_entry/0"},{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"blame/3","anchor":"blame/3"},{"id":"blame_mfa/3","anchor":"blame_mfa/3"},{"id":"exception?/1","anchor":"exception?/1"},{"id":"format/3","anchor":"format/3"},{"id":"format_banner/3","anchor":"format_banner/3"},{"id":"format_exit/1","anchor":"format_exit/1"},{"id":"format_fa/2","anchor":"format_fa/2"},{"id":"format_file_line/3","anchor":"format_file_line/3"},{"id":"format_mfa/3","anchor":"format_mfa/3"},{"id":"format_stacktrace/1","anchor":"format_stacktrace/1"},{"id":"format_stacktrace_entry/1","anchor":"format_stacktrace_entry/1"},{"id":"message/1","anchor":"message/1"},{"id":"normalize/3","anchor":"normalize/3"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"blame/2","anchor":"c:blame/2"},{"id":"exception/1","anchor":"c:exception/1"},{"id":"message/1","anchor":"c:message/1"}]}]},{"id":"Float","title":"Float","group":"Basic Types","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"precision_range/0","anchor":"t:precision_range/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"ceil/2","anchor":"ceil/2"},{"id":"floor/2","anchor":"floor/2"},{"id":"parse/1","anchor":"parse/1"},{"id":"ratio/1","anchor":"ratio/1"},{"id":"round/2","anchor":"round/2"},{"id":"to_charlist/1","anchor":"to_charlist/1"},{"id":"to_string/1","anchor":"to_string/1"}]}]},{"id":"Function","title":"Function","group":"Basic Types","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"information/0","anchor":"t:information/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"capture/3","anchor":"capture/3"},{"id":"info/1","anchor":"info/1"},{"id":"info/2","anchor":"info/2"}]}]},{"id":"Integer","title":"Integer","group":"Basic Types","nodeGroups":[{"key":"guards","name":"Guards","nodes":[{"id":"is_even/1","anchor":"is_even/1"},{"id":"is_odd/1","anchor":"is_odd/1"}]},{"key":"functions","name":"Functions","nodes":[{"id":"digits/2","anchor":"digits/2"},{"id":"floor_div/2","anchor":"floor_div/2"},{"id":"gcd/2","anchor":"gcd/2"},{"id":"mod/2","anchor":"mod/2"},{"id":"parse/2","anchor":"parse/2"},{"id":"to_charlist/1","anchor":"to_charlist/1"},{"id":"to_charlist/2","anchor":"to_charlist/2"},{"id":"to_string/1","anchor":"to_string/1"},{"id":"to_string/2","anchor":"to_string/2"},{"id":"undigits/2","anchor":"undigits/2"}]}]},{"id":"Module","title":"Module","group":"Basic Types","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"concat/1","anchor":"concat/1"},{"id":"concat/2","anchor":"concat/2"},{"id":"create/3","anchor":"create/3"},{"id":"defines?/2","anchor":"defines?/2"},{"id":"defines?/3","anchor":"defines?/3"},{"id":"defines_type?/2","anchor":"defines_type?/2"},{"id":"definitions_in/1","anchor":"definitions_in/1"},{"id":"definitions_in/2","anchor":"definitions_in/2"},{"id":"delete_attribute/2","anchor":"delete_attribute/2"},{"id":"eval_quoted/4","anchor":"eval_quoted/4"},{"id":"get_attribute/3","anchor":"get_attribute/3"},{"id":"make_overridable/2","anchor":"make_overridable/2"},{"id":"open?/1","anchor":"open?/1"},{"id":"overridable?/2","anchor":"overridable?/2"},{"id":"put_attribute/3","anchor":"put_attribute/3"},{"id":"register_attribute/3","anchor":"register_attribute/3"},{"id":"safe_concat/1","anchor":"safe_concat/1"},{"id":"safe_concat/2","anchor":"safe_concat/2"},{"id":"spec_to_callback/2","anchor":"spec_to_callback/2"},{"id":"split/1","anchor":"split/1"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"__info__/1","anchor":"c:__info__/1"}]}]},{"id":"NaiveDateTime","title":"NaiveDateTime","group":"Basic Types","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"add/3","anchor":"add/3"},{"id":"compare/2","anchor":"compare/2"},{"id":"convert/2","anchor":"convert/2"},{"id":"convert!/2","anchor":"convert!/2"},{"id":"diff/3","anchor":"diff/3"},{"id":"from_erl/3","anchor":"from_erl/3"},{"id":"from_erl!/3","anchor":"from_erl!/3"},{"id":"from_iso8601/2","anchor":"from_iso8601/2"},{"id":"from_iso8601!/2","anchor":"from_iso8601!/2"},{"id":"new/2","anchor":"new/2"},{"id":"new/8","anchor":"new/8"},{"id":"to_date/1","anchor":"to_date/1"},{"id":"to_erl/1","anchor":"to_erl/1"},{"id":"to_iso8601/2","anchor":"to_iso8601/2"},{"id":"to_string/1","anchor":"to_string/1"},{"id":"to_time/1","anchor":"to_time/1"},{"id":"truncate/2","anchor":"truncate/2"},{"id":"utc_now/1","anchor":"utc_now/1"}]}]},{"id":"Record","title":"Record","group":"Basic Types","nodeGroups":[{"key":"guards","name":"Guards","nodes":[{"id":"is_record/1","anchor":"is_record/1"},{"id":"is_record/2","anchor":"is_record/2"}]},{"key":"functions","name":"Functions","nodes":[{"id":"defrecord/3","anchor":"defrecord/3"},{"id":"defrecordp/3","anchor":"defrecordp/3"},{"id":"extract/2","anchor":"extract/2"},{"id":"extract_all/1","anchor":"extract_all/1"}]}]},{"id":"Regex","title":"Regex","group":"Basic Types","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"compile/2","anchor":"compile/2"},{"id":"compile!/2","anchor":"compile!/2"},{"id":"escape/1","anchor":"escape/1"},{"id":"match?/2","anchor":"match?/2"},{"id":"named_captures/3","anchor":"named_captures/3"},{"id":"names/1","anchor":"names/1"},{"id":"opts/1","anchor":"opts/1"},{"id":"re_pattern/1","anchor":"re_pattern/1"},{"id":"recompile/1","anchor":"recompile/1"},{"id":"recompile!/1","anchor":"recompile!/1"},{"id":"regex?/1","anchor":"regex?/1"},{"id":"replace/4","anchor":"replace/4"},{"id":"run/3","anchor":"run/3"},{"id":"scan/3","anchor":"scan/3"},{"id":"source/1","anchor":"source/1"},{"id":"split/3","anchor":"split/3"},{"id":"version/0","anchor":"version/0"}]}]},{"id":"String","title":"String","group":"Basic Types","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"codepoint/0","anchor":"t:codepoint/0"},{"id":"grapheme/0","anchor":"t:grapheme/0"},{"id":"pattern/0","anchor":"t:pattern/0"},{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"at/2","anchor":"at/2"},{"id":"bag_distance/2","anchor":"bag_distance/2"},{"id":"capitalize/2","anchor":"capitalize/2"},{"id":"chunk/2","anchor":"chunk/2"},{"id":"codepoints/1","anchor":"codepoints/1"},{"id":"contains?/2","anchor":"contains?/2"},{"id":"downcase/2","anchor":"downcase/2"},{"id":"duplicate/2","anchor":"duplicate/2"},{"id":"ends_with?/2","anchor":"ends_with?/2"},{"id":"equivalent?/2","anchor":"equivalent?/2"},{"id":"first/1","anchor":"first/1"},{"id":"graphemes/1","anchor":"graphemes/1"},{"id":"jaro_distance/2","anchor":"jaro_distance/2"},{"id":"last/1","anchor":"last/1"},{"id":"length/1","anchor":"length/1"},{"id":"match?/2","anchor":"match?/2"},{"id":"myers_difference/2","anchor":"myers_difference/2"},{"id":"next_codepoint/1","anchor":"next_codepoint/1"},{"id":"next_grapheme/1","anchor":"next_grapheme/1"},{"id":"next_grapheme_size/1","anchor":"next_grapheme_size/1"},{"id":"normalize/2","anchor":"normalize/2"},{"id":"pad_leading/3","anchor":"pad_leading/3"},{"id":"pad_trailing/3","anchor":"pad_trailing/3"},{"id":"printable?/2","anchor":"printable?/2"},{"id":"replace/4","anchor":"replace/4"},{"id":"replace_leading/3","anchor":"replace_leading/3"},{"id":"replace_prefix/3","anchor":"replace_prefix/3"},{"id":"replace_suffix/3","anchor":"replace_suffix/3"},{"id":"replace_trailing/3","anchor":"replace_trailing/3"},{"id":"reverse/1","anchor":"reverse/1"},{"id":"slice/2","anchor":"slice/2"},{"id":"slice/3","anchor":"slice/3"},{"id":"split/1","anchor":"split/1"},{"id":"split/3","anchor":"split/3"},{"id":"split_at/2","anchor":"split_at/2"},{"id":"splitter/3","anchor":"splitter/3"},{"id":"starts_with?/2","anchor":"starts_with?/2"},{"id":"to_atom/1","anchor":"to_atom/1"},{"id":"to_charlist/1","anchor":"to_charlist/1"},{"id":"to_existing_atom/1","anchor":"to_existing_atom/1"},{"id":"to_float/1","anchor":"to_float/1"},{"id":"to_integer/1","anchor":"to_integer/1"},{"id":"to_integer/2","anchor":"to_integer/2"},{"id":"trim/1","anchor":"trim/1"},{"id":"trim/2","anchor":"trim/2"},{"id":"trim_leading/1","anchor":"trim_leading/1"},{"id":"trim_leading/2","anchor":"trim_leading/2"},{"id":"trim_trailing/1","anchor":"trim_trailing/1"},{"id":"trim_trailing/2","anchor":"trim_trailing/2"},{"id":"upcase/2","anchor":"upcase/2"},{"id":"valid?/1","anchor":"valid?/1"}]}]},{"id":"Time","title":"Time","group":"Basic Types","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"add/3","anchor":"add/3"},{"id":"compare/2","anchor":"compare/2"},{"id":"convert/2","anchor":"convert/2"},{"id":"convert!/2","anchor":"convert!/2"},{"id":"diff/3","anchor":"diff/3"},{"id":"from_erl/3","anchor":"from_erl/3"},{"id":"from_erl!/3","anchor":"from_erl!/3"},{"id":"from_iso8601/2","anchor":"from_iso8601/2"},{"id":"from_iso8601!/2","anchor":"from_iso8601!/2"},{"id":"new/5","anchor":"new/5"},{"id":"to_erl/1","anchor":"to_erl/1"},{"id":"to_iso8601/2","anchor":"to_iso8601/2"},{"id":"to_string/1","anchor":"to_string/1"},{"id":"truncate/2","anchor":"truncate/2"},{"id":"utc_now/1","anchor":"utc_now/1"}]}]},{"id":"Tuple","title":"Tuple","group":"Basic Types","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"append/2","anchor":"append/2"},{"id":"delete_at/2","anchor":"delete_at/2"},{"id":"duplicate/2","anchor":"duplicate/2"},{"id":"insert_at/3","anchor":"insert_at/3"},{"id":"to_list/1","anchor":"to_list/1"}]}]},{"id":"URI","title":"URI","group":"Basic Types","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"char_reserved?/1","anchor":"char_reserved?/1"},{"id":"char_unescaped?/1","anchor":"char_unescaped?/1"},{"id":"char_unreserved?/1","anchor":"char_unreserved?/1"},{"id":"decode/1","anchor":"decode/1"},{"id":"decode_query/2","anchor":"decode_query/2"},{"id":"decode_www_form/1","anchor":"decode_www_form/1"},{"id":"default_port/1","anchor":"default_port/1"},{"id":"default_port/2","anchor":"default_port/2"},{"id":"encode/2","anchor":"encode/2"},{"id":"encode_query/1","anchor":"encode_query/1"},{"id":"encode_www_form/1","anchor":"encode_www_form/1"},{"id":"merge/2","anchor":"merge/2"},{"id":"parse/1","anchor":"parse/1"},{"id":"query_decoder/1","anchor":"query_decoder/1"},{"id":"to_string/1","anchor":"to_string/1"}]}]},{"id":"Version","title":"Version","group":"Basic Types","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"build/0","anchor":"t:build/0"},{"id":"major/0","anchor":"t:major/0"},{"id":"minor/0","anchor":"t:minor/0"},{"id":"patch/0","anchor":"t:patch/0"},{"id":"pre/0","anchor":"t:pre/0"},{"id":"requirement/0","anchor":"t:requirement/0"},{"id":"t/0","anchor":"t:t/0"},{"id":"version/0","anchor":"t:version/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"compare/2","anchor":"compare/2"},{"id":"compile_requirement/1","anchor":"compile_requirement/1"},{"id":"match?/3","anchor":"match?/3"},{"id":"parse/1","anchor":"parse/1"},{"id":"parse!/1","anchor":"parse!/1"},{"id":"parse_requirement/1","anchor":"parse_requirement/1"},{"id":"parse_requirement!/1","anchor":"parse_requirement!/1"}]}]},{"id":"Version.Requirement","title":"Version.Requirement","group":"Basic Types","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]}]},{"id":"Access","title":"Access","group":"Collections & Enumerables","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"access_fun/2","anchor":"t:access_fun/2"},{"id":"any_container/0","anchor":"t:any_container/0"},{"id":"container/0","anchor":"t:container/0"},{"id":"get_and_update_fun/2","anchor":"t:get_and_update_fun/2"},{"id":"get_fun/2","anchor":"t:get_fun/2"},{"id":"key/0","anchor":"t:key/0"},{"id":"nil_container/0","anchor":"t:nil_container/0"},{"id":"t/0","anchor":"t:t/0"},{"id":"value/0","anchor":"t:value/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"all/0","anchor":"all/0"},{"id":"at/1","anchor":"at/1"},{"id":"elem/1","anchor":"elem/1"},{"id":"fetch/2","anchor":"fetch/2"},{"id":"filter/1","anchor":"filter/1"},{"id":"get/3","anchor":"get/3"},{"id":"get_and_update/3","anchor":"get_and_update/3"},{"id":"key/2","anchor":"key/2"},{"id":"key!/1","anchor":"key!/1"},{"id":"pop/2","anchor":"pop/2"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"fetch/2","anchor":"c:fetch/2"},{"id":"get_and_update/3","anchor":"c:get_and_update/3"},{"id":"pop/2","anchor":"c:pop/2"}]}]},{"id":"Date.Range","title":"Date.Range","group":"Collections & Enumerables","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]}]},{"id":"Enum","title":"Enum","group":"Collections & Enumerables","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"acc/0","anchor":"t:acc/0"},{"id":"default/0","anchor":"t:default/0"},{"id":"element/0","anchor":"t:element/0"},{"id":"index/0","anchor":"t:index/0"},{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"all?/2","anchor":"all?/2"},{"id":"any?/2","anchor":"any?/2"},{"id":"at/3","anchor":"at/3"},{"id":"chunk_by/2","anchor":"chunk_by/2"},{"id":"chunk_every/2","anchor":"chunk_every/2"},{"id":"chunk_every/4","anchor":"chunk_every/4"},{"id":"chunk_while/4","anchor":"chunk_while/4"},{"id":"concat/1","anchor":"concat/1"},{"id":"concat/2","anchor":"concat/2"},{"id":"count/1","anchor":"count/1"},{"id":"count/2","anchor":"count/2"},{"id":"dedup/1","anchor":"dedup/1"},{"id":"dedup_by/2","anchor":"dedup_by/2"},{"id":"drop/2","anchor":"drop/2"},{"id":"drop_every/2","anchor":"drop_every/2"},{"id":"drop_while/2","anchor":"drop_while/2"},{"id":"each/2","anchor":"each/2"},{"id":"empty?/1","anchor":"empty?/1"},{"id":"fetch/2","anchor":"fetch/2"},{"id":"fetch!/2","anchor":"fetch!/2"},{"id":"filter/2","anchor":"filter/2"},{"id":"find/3","anchor":"find/3"},{"id":"find_index/2","anchor":"find_index/2"},{"id":"find_value/3","anchor":"find_value/3"},{"id":"flat_map/2","anchor":"flat_map/2"},{"id":"flat_map_reduce/3","anchor":"flat_map_reduce/3"},{"id":"group_by/3","anchor":"group_by/3"},{"id":"intersperse/2","anchor":"intersperse/2"},{"id":"into/2","anchor":"into/2"},{"id":"into/3","anchor":"into/3"},{"id":"join/2","anchor":"join/2"},{"id":"map/2","anchor":"map/2"},{"id":"map_every/3","anchor":"map_every/3"},{"id":"map_join/3","anchor":"map_join/3"},{"id":"map_reduce/3","anchor":"map_reduce/3"},{"id":"max/2","anchor":"max/2"},{"id":"max_by/3","anchor":"max_by/3"},{"id":"member?/2","anchor":"member?/2"},{"id":"min/2","anchor":"min/2"},{"id":"min_by/3","anchor":"min_by/3"},{"id":"min_max/2","anchor":"min_max/2"},{"id":"min_max_by/3","anchor":"min_max_by/3"},{"id":"random/1","anchor":"random/1"},{"id":"reduce/2","anchor":"reduce/2"},{"id":"reduce/3","anchor":"reduce/3"},{"id":"reduce_while/3","anchor":"reduce_while/3"},{"id":"reject/2","anchor":"reject/2"},{"id":"reverse/1","anchor":"reverse/1"},{"id":"reverse/2","anchor":"reverse/2"},{"id":"reverse_slice/3","anchor":"reverse_slice/3"},{"id":"scan/2","anchor":"scan/2"},{"id":"scan/3","anchor":"scan/3"},{"id":"shuffle/1","anchor":"shuffle/1"},{"id":"slice/2","anchor":"slice/2"},{"id":"slice/3","anchor":"slice/3"},{"id":"sort/1","anchor":"sort/1"},{"id":"sort/2","anchor":"sort/2"},{"id":"sort_by/3","anchor":"sort_by/3"},{"id":"split/2","anchor":"split/2"},{"id":"split_while/2","anchor":"split_while/2"},{"id":"split_with/2","anchor":"split_with/2"},{"id":"sum/1","anchor":"sum/1"},{"id":"take/2","anchor":"take/2"},{"id":"take_every/2","anchor":"take_every/2"},{"id":"take_random/2","anchor":"take_random/2"},{"id":"take_while/2","anchor":"take_while/2"},{"id":"to_list/1","anchor":"to_list/1"},{"id":"uniq/1","anchor":"uniq/1"},{"id":"uniq_by/2","anchor":"uniq_by/2"},{"id":"unzip/1","anchor":"unzip/1"},{"id":"with_index/2","anchor":"with_index/2"},{"id":"zip/1","anchor":"zip/1"},{"id":"zip/2","anchor":"zip/2"}]}]},{"id":"Keyword","title":"Keyword","group":"Collections & Enumerables","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"key/0","anchor":"t:key/0"},{"id":"t/0","anchor":"t:t/0"},{"id":"t/1","anchor":"t:t/1"},{"id":"value/0","anchor":"t:value/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"delete/2","anchor":"delete/2"},{"id":"delete/3","anchor":"delete/3"},{"id":"delete_first/2","anchor":"delete_first/2"},{"id":"drop/2","anchor":"drop/2"},{"id":"equal?/2","anchor":"equal?/2"},{"id":"fetch/2","anchor":"fetch/2"},{"id":"fetch!/2","anchor":"fetch!/2"},{"id":"get/3","anchor":"get/3"},{"id":"get_and_update/3","anchor":"get_and_update/3"},{"id":"get_and_update!/3","anchor":"get_and_update!/3"},{"id":"get_lazy/3","anchor":"get_lazy/3"},{"id":"get_values/2","anchor":"get_values/2"},{"id":"has_key?/2","anchor":"has_key?/2"},{"id":"keys/1","anchor":"keys/1"},{"id":"keyword?/1","anchor":"keyword?/1"},{"id":"merge/2","anchor":"merge/2"},{"id":"merge/3","anchor":"merge/3"},{"id":"new/0","anchor":"new/0"},{"id":"new/1","anchor":"new/1"},{"id":"new/2","anchor":"new/2"},{"id":"pop/3","anchor":"pop/3"},{"id":"pop_first/3","anchor":"pop_first/3"},{"id":"pop_lazy/3","anchor":"pop_lazy/3"},{"id":"put/3","anchor":"put/3"},{"id":"put_new/3","anchor":"put_new/3"},{"id":"put_new_lazy/3","anchor":"put_new_lazy/3"},{"id":"replace!/3","anchor":"replace!/3"},{"id":"split/2","anchor":"split/2"},{"id":"take/2","anchor":"take/2"},{"id":"to_list/1","anchor":"to_list/1"},{"id":"update/4","anchor":"update/4"},{"id":"update!/3","anchor":"update!/3"},{"id":"values/1","anchor":"values/1"}]}]},{"id":"List","title":"List","group":"Collections & Enumerables","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"ascii_printable?/2","anchor":"ascii_printable?/2"},{"id":"delete/2","anchor":"delete/2"},{"id":"delete_at/2","anchor":"delete_at/2"},{"id":"duplicate/2","anchor":"duplicate/2"},{"id":"first/1","anchor":"first/1"},{"id":"flatten/1","anchor":"flatten/1"},{"id":"flatten/2","anchor":"flatten/2"},{"id":"foldl/3","anchor":"foldl/3"},{"id":"foldr/3","anchor":"foldr/3"},{"id":"improper?/1","anchor":"improper?/1"},{"id":"insert_at/3","anchor":"insert_at/3"},{"id":"keydelete/3","anchor":"keydelete/3"},{"id":"keyfind/4","anchor":"keyfind/4"},{"id":"keymember?/3","anchor":"keymember?/3"},{"id":"keyreplace/4","anchor":"keyreplace/4"},{"id":"keysort/2","anchor":"keysort/2"},{"id":"keystore/4","anchor":"keystore/4"},{"id":"keytake/3","anchor":"keytake/3"},{"id":"last/1","anchor":"last/1"},{"id":"myers_difference/2","anchor":"myers_difference/2"},{"id":"myers_difference/3","anchor":"myers_difference/3"},{"id":"pop_at/3","anchor":"pop_at/3"},{"id":"replace_at/3","anchor":"replace_at/3"},{"id":"starts_with?/2","anchor":"starts_with?/2"},{"id":"to_atom/1","anchor":"to_atom/1"},{"id":"to_charlist/1","anchor":"to_charlist/1"},{"id":"to_existing_atom/1","anchor":"to_existing_atom/1"},{"id":"to_float/1","anchor":"to_float/1"},{"id":"to_integer/1","anchor":"to_integer/1"},{"id":"to_integer/2","anchor":"to_integer/2"},{"id":"to_string/1","anchor":"to_string/1"},{"id":"to_tuple/1","anchor":"to_tuple/1"},{"id":"update_at/3","anchor":"update_at/3"},{"id":"wrap/1","anchor":"wrap/1"},{"id":"zip/1","anchor":"zip/1"}]}]},{"id":"Map","title":"Map","group":"Collections & Enumerables","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"key/0","anchor":"t:key/0"},{"id":"value/0","anchor":"t:value/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"delete/2","anchor":"delete/2"},{"id":"drop/2","anchor":"drop/2"},{"id":"equal?/2","anchor":"equal?/2"},{"id":"fetch/2","anchor":"fetch/2"},{"id":"fetch!/2","anchor":"fetch!/2"},{"id":"from_struct/1","anchor":"from_struct/1"},{"id":"get/3","anchor":"get/3"},{"id":"get_and_update/3","anchor":"get_and_update/3"},{"id":"get_and_update!/3","anchor":"get_and_update!/3"},{"id":"get_lazy/3","anchor":"get_lazy/3"},{"id":"has_key?/2","anchor":"has_key?/2"},{"id":"keys/1","anchor":"keys/1"},{"id":"merge/2","anchor":"merge/2"},{"id":"merge/3","anchor":"merge/3"},{"id":"new/0","anchor":"new/0"},{"id":"new/1","anchor":"new/1"},{"id":"new/2","anchor":"new/2"},{"id":"pop/3","anchor":"pop/3"},{"id":"pop_lazy/3","anchor":"pop_lazy/3"},{"id":"put/3","anchor":"put/3"},{"id":"put_new/3","anchor":"put_new/3"},{"id":"put_new_lazy/3","anchor":"put_new_lazy/3"},{"id":"replace!/3","anchor":"replace!/3"},{"id":"split/2","anchor":"split/2"},{"id":"take/2","anchor":"take/2"},{"id":"to_list/1","anchor":"to_list/1"},{"id":"update/4","anchor":"update/4"},{"id":"update!/3","anchor":"update!/3"},{"id":"values/1","anchor":"values/1"}]}]},{"id":"MapSet","title":"MapSet","group":"Collections & Enumerables","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"},{"id":"t/1","anchor":"t:t/1"},{"id":"value/0","anchor":"t:value/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"delete/2","anchor":"delete/2"},{"id":"difference/2","anchor":"difference/2"},{"id":"disjoint?/2","anchor":"disjoint?/2"},{"id":"equal?/2","anchor":"equal?/2"},{"id":"intersection/2","anchor":"intersection/2"},{"id":"member?/2","anchor":"member?/2"},{"id":"new/0","anchor":"new/0"},{"id":"new/1","anchor":"new/1"},{"id":"new/2","anchor":"new/2"},{"id":"put/2","anchor":"put/2"},{"id":"size/1","anchor":"size/1"},{"id":"subset?/2","anchor":"subset?/2"},{"id":"to_list/1","anchor":"to_list/1"},{"id":"union/2","anchor":"union/2"}]}]},{"id":"Range","title":"Range","group":"Collections & Enumerables","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"},{"id":"t/2","anchor":"t:t/2"}]},{"key":"functions","name":"Functions","nodes":[{"id":"disjoint?/2","anchor":"disjoint?/2"},{"id":"new/2","anchor":"new/2"}]}]},{"id":"Stream","title":"Stream","group":"Collections & Enumerables","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"acc/0","anchor":"t:acc/0"},{"id":"default/0","anchor":"t:default/0"},{"id":"element/0","anchor":"t:element/0"},{"id":"index/0","anchor":"t:index/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"chunk_by/2","anchor":"chunk_by/2"},{"id":"chunk_every/2","anchor":"chunk_every/2"},{"id":"chunk_every/4","anchor":"chunk_every/4"},{"id":"chunk_while/4","anchor":"chunk_while/4"},{"id":"concat/1","anchor":"concat/1"},{"id":"concat/2","anchor":"concat/2"},{"id":"cycle/1","anchor":"cycle/1"},{"id":"dedup/1","anchor":"dedup/1"},{"id":"dedup_by/2","anchor":"dedup_by/2"},{"id":"drop/2","anchor":"drop/2"},{"id":"drop_every/2","anchor":"drop_every/2"},{"id":"drop_while/2","anchor":"drop_while/2"},{"id":"each/2","anchor":"each/2"},{"id":"filter/2","anchor":"filter/2"},{"id":"flat_map/2","anchor":"flat_map/2"},{"id":"intersperse/2","anchor":"intersperse/2"},{"id":"interval/1","anchor":"interval/1"},{"id":"into/3","anchor":"into/3"},{"id":"iterate/2","anchor":"iterate/2"},{"id":"map/2","anchor":"map/2"},{"id":"map_every/3","anchor":"map_every/3"},{"id":"reject/2","anchor":"reject/2"},{"id":"repeatedly/1","anchor":"repeatedly/1"},{"id":"resource/3","anchor":"resource/3"},{"id":"run/1","anchor":"run/1"},{"id":"scan/2","anchor":"scan/2"},{"id":"scan/3","anchor":"scan/3"},{"id":"take/2","anchor":"take/2"},{"id":"take_every/2","anchor":"take_every/2"},{"id":"take_while/2","anchor":"take_while/2"},{"id":"timer/1","anchor":"timer/1"},{"id":"transform/3","anchor":"transform/3"},{"id":"transform/4","anchor":"transform/4"},{"id":"unfold/2","anchor":"unfold/2"},{"id":"uniq/1","anchor":"uniq/1"},{"id":"uniq_by/2","anchor":"uniq_by/2"},{"id":"with_index/2","anchor":"with_index/2"},{"id":"zip/1","anchor":"zip/1"},{"id":"zip/2","anchor":"zip/2"}]}]},{"id":"File","title":"File","group":"IO & System","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"encoding_mode/0","anchor":"t:encoding_mode/0"},{"id":"erlang_time/0","anchor":"t:erlang_time/0"},{"id":"io_device/0","anchor":"t:io_device/0"},{"id":"mode/0","anchor":"t:mode/0"},{"id":"posix/0","anchor":"t:posix/0"},{"id":"posix_time/0","anchor":"t:posix_time/0"},{"id":"stat_options/0","anchor":"t:stat_options/0"},{"id":"stream_mode/0","anchor":"t:stream_mode/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"cd/1","anchor":"cd/1"},{"id":"cd!/1","anchor":"cd!/1"},{"id":"cd!/2","anchor":"cd!/2"},{"id":"chgrp/2","anchor":"chgrp/2"},{"id":"chgrp!/2","anchor":"chgrp!/2"},{"id":"chmod/2","anchor":"chmod/2"},{"id":"chmod!/2","anchor":"chmod!/2"},{"id":"chown/2","anchor":"chown/2"},{"id":"chown!/2","anchor":"chown!/2"},{"id":"close/1","anchor":"close/1"},{"id":"copy/3","anchor":"copy/3"},{"id":"copy!/3","anchor":"copy!/3"},{"id":"cp/3","anchor":"cp/3"},{"id":"cp!/3","anchor":"cp!/3"},{"id":"cp_r/3","anchor":"cp_r/3"},{"id":"cp_r!/3","anchor":"cp_r!/3"},{"id":"cwd/0","anchor":"cwd/0"},{"id":"cwd!/0","anchor":"cwd!/0"},{"id":"dir?/2","anchor":"dir?/2"},{"id":"exists?/2","anchor":"exists?/2"},{"id":"ln/2","anchor":"ln/2"},{"id":"ln!/2","anchor":"ln!/2"},{"id":"ln_s/2","anchor":"ln_s/2"},{"id":"ln_s!/2","anchor":"ln_s!/2"},{"id":"ls/1","anchor":"ls/1"},{"id":"ls!/1","anchor":"ls!/1"},{"id":"lstat/2","anchor":"lstat/2"},{"id":"lstat!/2","anchor":"lstat!/2"},{"id":"mkdir/1","anchor":"mkdir/1"},{"id":"mkdir!/1","anchor":"mkdir!/1"},{"id":"mkdir_p/1","anchor":"mkdir_p/1"},{"id":"mkdir_p!/1","anchor":"mkdir_p!/1"},{"id":"open/2","anchor":"open/2"},{"id":"open/3","anchor":"open/3"},{"id":"open!/2","anchor":"open!/2"},{"id":"open!/3","anchor":"open!/3"},{"id":"read/1","anchor":"read/1"},{"id":"read!/1","anchor":"read!/1"},{"id":"read_link/1","anchor":"read_link/1"},{"id":"read_link!/1","anchor":"read_link!/1"},{"id":"regular?/2","anchor":"regular?/2"},{"id":"rename/2","anchor":"rename/2"},{"id":"rename!/2","anchor":"rename!/2"},{"id":"rm/1","anchor":"rm/1"},{"id":"rm!/1","anchor":"rm!/1"},{"id":"rm_rf/1","anchor":"rm_rf/1"},{"id":"rm_rf!/1","anchor":"rm_rf!/1"},{"id":"rmdir/1","anchor":"rmdir/1"},{"id":"rmdir!/1","anchor":"rmdir!/1"},{"id":"stat/2","anchor":"stat/2"},{"id":"stat!/2","anchor":"stat!/2"},{"id":"stream!/3","anchor":"stream!/3"},{"id":"touch/2","anchor":"touch/2"},{"id":"touch!/2","anchor":"touch!/2"},{"id":"write/3","anchor":"write/3"},{"id":"write!/3","anchor":"write!/3"},{"id":"write_stat/3","anchor":"write_stat/3"},{"id":"write_stat!/3","anchor":"write_stat!/3"}]}]},{"id":"File.Stat","title":"File.Stat","group":"IO & System","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"from_record/1","anchor":"from_record/1"},{"id":"to_record/1","anchor":"to_record/1"}]}]},{"id":"File.Stream","title":"File.Stream","group":"IO & System","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]}]},{"id":"IO","title":"IO","group":"IO & System","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"chardata/0","anchor":"t:chardata/0"},{"id":"device/0","anchor":"t:device/0"},{"id":"nodata/0","anchor":"t:nodata/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"binread/2","anchor":"binread/2"},{"id":"binstream/2","anchor":"binstream/2"},{"id":"binwrite/2","anchor":"binwrite/2"},{"id":"chardata_to_string/1","anchor":"chardata_to_string/1"},{"id":"getn/2","anchor":"getn/2"},{"id":"getn/3","anchor":"getn/3"},{"id":"gets/2","anchor":"gets/2"},{"id":"inspect/2","anchor":"inspect/2"},{"id":"inspect/3","anchor":"inspect/3"},{"id":"iodata_length/1","anchor":"iodata_length/1"},{"id":"iodata_to_binary/1","anchor":"iodata_to_binary/1"},{"id":"puts/2","anchor":"puts/2"},{"id":"read/2","anchor":"read/2"},{"id":"stream/2","anchor":"stream/2"},{"id":"warn/1","anchor":"warn/1"},{"id":"warn/2","anchor":"warn/2"},{"id":"write/2","anchor":"write/2"}]}]},{"id":"IO.ANSI","title":"IO.ANSI","group":"IO & System","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"ansicode/0","anchor":"t:ansicode/0"},{"id":"ansidata/0","anchor":"t:ansidata/0"},{"id":"ansilist/0","anchor":"t:ansilist/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"black/0","anchor":"black/0"},{"id":"black_background/0","anchor":"black_background/0"},{"id":"blink_off/0","anchor":"blink_off/0"},{"id":"blink_rapid/0","anchor":"blink_rapid/0"},{"id":"blink_slow/0","anchor":"blink_slow/0"},{"id":"blue/0","anchor":"blue/0"},{"id":"blue_background/0","anchor":"blue_background/0"},{"id":"bright/0","anchor":"bright/0"},{"id":"clear/0","anchor":"clear/0"},{"id":"clear_line/0","anchor":"clear_line/0"},{"id":"color/1","anchor":"color/1"},{"id":"color/3","anchor":"color/3"},{"id":"color_background/1","anchor":"color_background/1"},{"id":"color_background/3","anchor":"color_background/3"},{"id":"conceal/0","anchor":"conceal/0"},{"id":"crossed_out/0","anchor":"crossed_out/0"},{"id":"cursor/2","anchor":"cursor/2"},{"id":"cursor_down/1","anchor":"cursor_down/1"},{"id":"cursor_left/1","anchor":"cursor_left/1"},{"id":"cursor_right/1","anchor":"cursor_right/1"},{"id":"cursor_up/1","anchor":"cursor_up/1"},{"id":"cyan/0","anchor":"cyan/0"},{"id":"cyan_background/0","anchor":"cyan_background/0"},{"id":"default_background/0","anchor":"default_background/0"},{"id":"default_color/0","anchor":"default_color/0"},{"id":"enabled?/0","anchor":"enabled?/0"},{"id":"encircled/0","anchor":"encircled/0"},{"id":"faint/0","anchor":"faint/0"},{"id":"font_1/0","anchor":"font_1/0"},{"id":"font_2/0","anchor":"font_2/0"},{"id":"font_3/0","anchor":"font_3/0"},{"id":"font_4/0","anchor":"font_4/0"},{"id":"font_5/0","anchor":"font_5/0"},{"id":"font_6/0","anchor":"font_6/0"},{"id":"font_7/0","anchor":"font_7/0"},{"id":"font_8/0","anchor":"font_8/0"},{"id":"font_9/0","anchor":"font_9/0"},{"id":"format/2","anchor":"format/2"},{"id":"format_fragment/2","anchor":"format_fragment/2"},{"id":"framed/0","anchor":"framed/0"},{"id":"green/0","anchor":"green/0"},{"id":"green_background/0","anchor":"green_background/0"},{"id":"home/0","anchor":"home/0"},{"id":"inverse/0","anchor":"inverse/0"},{"id":"inverse_off/0","anchor":"inverse_off/0"},{"id":"italic/0","anchor":"italic/0"},{"id":"light_black/0","anchor":"light_black/0"},{"id":"light_black_background/0","anchor":"light_black_background/0"},{"id":"light_blue/0","anchor":"light_blue/0"},{"id":"light_blue_background/0","anchor":"light_blue_background/0"},{"id":"light_cyan/0","anchor":"light_cyan/0"},{"id":"light_cyan_background/0","anchor":"light_cyan_background/0"},{"id":"light_green/0","anchor":"light_green/0"},{"id":"light_green_background/0","anchor":"light_green_background/0"},{"id":"light_magenta/0","anchor":"light_magenta/0"},{"id":"light_magenta_background/0","anchor":"light_magenta_background/0"},{"id":"light_red/0","anchor":"light_red/0"},{"id":"light_red_background/0","anchor":"light_red_background/0"},{"id":"light_white/0","anchor":"light_white/0"},{"id":"light_white_background/0","anchor":"light_white_background/0"},{"id":"light_yellow/0","anchor":"light_yellow/0"},{"id":"light_yellow_background/0","anchor":"light_yellow_background/0"},{"id":"magenta/0","anchor":"magenta/0"},{"id":"magenta_background/0","anchor":"magenta_background/0"},{"id":"no_underline/0","anchor":"no_underline/0"},{"id":"normal/0","anchor":"normal/0"},{"id":"not_framed_encircled/0","anchor":"not_framed_encircled/0"},{"id":"not_italic/0","anchor":"not_italic/0"},{"id":"not_overlined/0","anchor":"not_overlined/0"},{"id":"overlined/0","anchor":"overlined/0"},{"id":"primary_font/0","anchor":"primary_font/0"},{"id":"red/0","anchor":"red/0"},{"id":"red_background/0","anchor":"red_background/0"},{"id":"reset/0","anchor":"reset/0"},{"id":"reverse/0","anchor":"reverse/0"},{"id":"reverse_off/0","anchor":"reverse_off/0"},{"id":"underline/0","anchor":"underline/0"},{"id":"white/0","anchor":"white/0"},{"id":"white_background/0","anchor":"white_background/0"},{"id":"yellow/0","anchor":"yellow/0"},{"id":"yellow_background/0","anchor":"yellow_background/0"}]}]},{"id":"IO.Stream","title":"IO.Stream","group":"IO & System","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]}]},{"id":"OptionParser","title":"OptionParser","group":"IO & System","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"argv/0","anchor":"t:argv/0"},{"id":"errors/0","anchor":"t:errors/0"},{"id":"options/0","anchor":"t:options/0"},{"id":"parsed/0","anchor":"t:parsed/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"next/2","anchor":"next/2"},{"id":"parse/2","anchor":"parse/2"},{"id":"parse!/2","anchor":"parse!/2"},{"id":"parse_head/2","anchor":"parse_head/2"},{"id":"parse_head!/2","anchor":"parse_head!/2"},{"id":"split/1","anchor":"split/1"},{"id":"to_argv/2","anchor":"to_argv/2"}]}]},{"id":"Path","title":"Path","group":"IO & System","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"absname/1","anchor":"absname/1"},{"id":"absname/2","anchor":"absname/2"},{"id":"basename/1","anchor":"basename/1"},{"id":"basename/2","anchor":"basename/2"},{"id":"dirname/1","anchor":"dirname/1"},{"id":"expand/1","anchor":"expand/1"},{"id":"expand/2","anchor":"expand/2"},{"id":"extname/1","anchor":"extname/1"},{"id":"join/1","anchor":"join/1"},{"id":"join/2","anchor":"join/2"},{"id":"relative/1","anchor":"relative/1"},{"id":"relative_to/2","anchor":"relative_to/2"},{"id":"relative_to_cwd/1","anchor":"relative_to_cwd/1"},{"id":"rootname/1","anchor":"rootname/1"},{"id":"rootname/2","anchor":"rootname/2"},{"id":"split/1","anchor":"split/1"},{"id":"type/1","anchor":"type/1"},{"id":"wildcard/2","anchor":"wildcard/2"}]}]},{"id":"Port","title":"Port","group":"IO & System","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"name/0","anchor":"t:name/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"close/1","anchor":"close/1"},{"id":"command/3","anchor":"command/3"},{"id":"connect/2","anchor":"connect/2"},{"id":"demonitor/2","anchor":"demonitor/2"},{"id":"info/1","anchor":"info/1"},{"id":"info/2","anchor":"info/2"},{"id":"list/0","anchor":"list/0"},{"id":"monitor/1","anchor":"monitor/1"},{"id":"open/2","anchor":"open/2"}]}]},{"id":"StringIO","title":"StringIO","group":"IO & System","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"close/1","anchor":"close/1"},{"id":"contents/1","anchor":"contents/1"},{"id":"flush/1","anchor":"flush/1"},{"id":"open/2","anchor":"open/2"},{"id":"open/3","anchor":"open/3"}]}]},{"id":"System","title":"System","group":"IO & System","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"time_unit/0","anchor":"t:time_unit/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"argv/0","anchor":"argv/0"},{"id":"argv/1","anchor":"argv/1"},{"id":"at_exit/1","anchor":"at_exit/1"},{"id":"build_info/0","anchor":"build_info/0"},{"id":"cmd/3","anchor":"cmd/3"},{"id":"compiled_endianness/0","anchor":"compiled_endianness/0"},{"id":"convert_time_unit/3","anchor":"convert_time_unit/3"},{"id":"cwd/0","anchor":"cwd/0"},{"id":"cwd!/0","anchor":"cwd!/0"},{"id":"delete_env/1","anchor":"delete_env/1"},{"id":"endianness/0","anchor":"endianness/0"},{"id":"fetch_env/1","anchor":"fetch_env/1"},{"id":"fetch_env!/1","anchor":"fetch_env!/1"},{"id":"find_executable/1","anchor":"find_executable/1"},{"id":"get_env/0","anchor":"get_env/0"},{"id":"get_env/2","anchor":"get_env/2"},{"id":"get_pid/0","anchor":"get_pid/0"},{"id":"halt/1","anchor":"halt/1"},{"id":"monotonic_time/0","anchor":"monotonic_time/0"},{"id":"monotonic_time/1","anchor":"monotonic_time/1"},{"id":"no_halt/0","anchor":"no_halt/0"},{"id":"no_halt/1","anchor":"no_halt/1"},{"id":"os_time/0","anchor":"os_time/0"},{"id":"os_time/1","anchor":"os_time/1"},{"id":"otp_release/0","anchor":"otp_release/0"},{"id":"pid/0","anchor":"pid/0"},{"id":"put_env/1","anchor":"put_env/1"},{"id":"put_env/2","anchor":"put_env/2"},{"id":"restart/0","anchor":"restart/0"},{"id":"schedulers/0","anchor":"schedulers/0"},{"id":"schedulers_online/0","anchor":"schedulers_online/0"},{"id":"stacktrace/0","anchor":"stacktrace/0"},{"id":"stop/1","anchor":"stop/1"},{"id":"system_time/0","anchor":"system_time/0"},{"id":"system_time/1","anchor":"system_time/1"},{"id":"time_offset/0","anchor":"time_offset/0"},{"id":"time_offset/1","anchor":"time_offset/1"},{"id":"tmp_dir/0","anchor":"tmp_dir/0"},{"id":"tmp_dir!/0","anchor":"tmp_dir!/0"},{"id":"unique_integer/1","anchor":"unique_integer/1"},{"id":"user_home/0","anchor":"user_home/0"},{"id":"user_home!/0","anchor":"user_home!/0"},{"id":"version/0","anchor":"version/0"}]}]},{"id":"Calendar","title":"Calendar","group":"Calendar","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"calendar/0","anchor":"t:calendar/0"},{"id":"date/0","anchor":"t:date/0"},{"id":"datetime/0","anchor":"t:datetime/0"},{"id":"day/0","anchor":"t:day/0"},{"id":"day_fraction/0","anchor":"t:day_fraction/0"},{"id":"day_of_week/0","anchor":"t:day_of_week/0"},{"id":"era/0","anchor":"t:era/0"},{"id":"hour/0","anchor":"t:hour/0"},{"id":"iso_days/0","anchor":"t:iso_days/0"},{"id":"microsecond/0","anchor":"t:microsecond/0"},{"id":"minute/0","anchor":"t:minute/0"},{"id":"month/0","anchor":"t:month/0"},{"id":"naive_datetime/0","anchor":"t:naive_datetime/0"},{"id":"second/0","anchor":"t:second/0"},{"id":"std_offset/0","anchor":"t:std_offset/0"},{"id":"time/0","anchor":"t:time/0"},{"id":"time_zone/0","anchor":"t:time_zone/0"},{"id":"time_zone_database/0","anchor":"t:time_zone_database/0"},{"id":"utc_offset/0","anchor":"t:utc_offset/0"},{"id":"week/0","anchor":"t:week/0"},{"id":"year/0","anchor":"t:year/0"},{"id":"zone_abbr/0","anchor":"t:zone_abbr/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"compatible_calendars?/2","anchor":"compatible_calendars?/2"},{"id":"get_time_zone_database/0","anchor":"get_time_zone_database/0"},{"id":"put_time_zone_database/1","anchor":"put_time_zone_database/1"},{"id":"truncate/2","anchor":"truncate/2"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"date_to_string/3","anchor":"c:date_to_string/3"},{"id":"datetime_to_string/11","anchor":"c:datetime_to_string/11"},{"id":"day_of_era/3","anchor":"c:day_of_era/3"},{"id":"day_of_week/3","anchor":"c:day_of_week/3"},{"id":"day_of_year/3","anchor":"c:day_of_year/3"},{"id":"day_rollover_relative_to_midnight_utc/0","anchor":"c:day_rollover_relative_to_midnight_utc/0"},{"id":"days_in_month/2","anchor":"c:days_in_month/2"},{"id":"leap_year?/1","anchor":"c:leap_year?/1"},{"id":"months_in_year/1","anchor":"c:months_in_year/1"},{"id":"naive_datetime_from_iso_days/1","anchor":"c:naive_datetime_from_iso_days/1"},{"id":"naive_datetime_to_iso_days/7","anchor":"c:naive_datetime_to_iso_days/7"},{"id":"naive_datetime_to_string/7","anchor":"c:naive_datetime_to_string/7"},{"id":"quarter_of_year/3","anchor":"c:quarter_of_year/3"},{"id":"time_from_day_fraction/1","anchor":"c:time_from_day_fraction/1"},{"id":"time_to_day_fraction/4","anchor":"c:time_to_day_fraction/4"},{"id":"time_to_string/4","anchor":"c:time_to_string/4"},{"id":"valid_date?/3","anchor":"c:valid_date?/3"},{"id":"valid_time?/4","anchor":"c:valid_time?/4"},{"id":"year_of_era/1","anchor":"c:year_of_era/1"}]}]},{"id":"Calendar.ISO","title":"Calendar.ISO","group":"Calendar","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"day/0","anchor":"t:day/0"},{"id":"month/0","anchor":"t:month/0"},{"id":"year/0","anchor":"t:year/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"date_to_string/4","anchor":"date_to_string/4"},{"id":"datetime_to_string/12","anchor":"datetime_to_string/12"},{"id":"day_of_era/3","anchor":"day_of_era/3"},{"id":"day_of_week/3","anchor":"day_of_week/3"},{"id":"day_of_year/3","anchor":"day_of_year/3"},{"id":"day_rollover_relative_to_midnight_utc/0","anchor":"day_rollover_relative_to_midnight_utc/0"},{"id":"days_in_month/2","anchor":"days_in_month/2"},{"id":"leap_year?/1","anchor":"leap_year?/1"},{"id":"months_in_year/1","anchor":"months_in_year/1"},{"id":"naive_datetime_from_iso_days/1","anchor":"naive_datetime_from_iso_days/1"},{"id":"naive_datetime_to_iso_days/7","anchor":"naive_datetime_to_iso_days/7"},{"id":"naive_datetime_to_string/8","anchor":"naive_datetime_to_string/8"},{"id":"quarter_of_year/3","anchor":"quarter_of_year/3"},{"id":"time_from_day_fraction/1","anchor":"time_from_day_fraction/1"},{"id":"time_to_day_fraction/4","anchor":"time_to_day_fraction/4"},{"id":"time_to_string/5","anchor":"time_to_string/5"},{"id":"valid_date?/3","anchor":"valid_date?/3"},{"id":"valid_time?/4","anchor":"valid_time?/4"},{"id":"year_of_era/1","anchor":"year_of_era/1"}]}]},{"id":"Calendar.TimeZoneDatabase","title":"Calendar.TimeZoneDatabase","group":"Calendar","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"time_zone_period/0","anchor":"t:time_zone_period/0"},{"id":"time_zone_period_limit/0","anchor":"t:time_zone_period_limit/0"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"time_zone_period_from_utc_iso_days/2","anchor":"c:time_zone_period_from_utc_iso_days/2"},{"id":"time_zone_periods_from_wall_datetime/2","anchor":"c:time_zone_periods_from_wall_datetime/2"}]}]},{"id":"Calendar.UTCOnlyTimeZoneDatabase","title":"Calendar.UTCOnlyTimeZoneDatabase","group":"Calendar"},{"id":"Agent","title":"Agent","group":"Processes & Applications","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"agent/0","anchor":"t:agent/0"},{"id":"name/0","anchor":"t:name/0"},{"id":"on_start/0","anchor":"t:on_start/0"},{"id":"state/0","anchor":"t:state/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"cast/2","anchor":"cast/2"},{"id":"cast/4","anchor":"cast/4"},{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"get/3","anchor":"get/3"},{"id":"get/5","anchor":"get/5"},{"id":"get_and_update/3","anchor":"get_and_update/3"},{"id":"get_and_update/5","anchor":"get_and_update/5"},{"id":"start/2","anchor":"start/2"},{"id":"start/4","anchor":"start/4"},{"id":"start_link/2","anchor":"start_link/2"},{"id":"start_link/4","anchor":"start_link/4"},{"id":"stop/3","anchor":"stop/3"},{"id":"update/3","anchor":"update/3"},{"id":"update/5","anchor":"update/5"}]}]},{"id":"Application","title":"Application","group":"Processes & Applications","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"app/0","anchor":"t:app/0"},{"id":"application_key/0","anchor":"t:application_key/0"},{"id":"key/0","anchor":"t:key/0"},{"id":"restart_type/0","anchor":"t:restart_type/0"},{"id":"start_type/0","anchor":"t:start_type/0"},{"id":"state/0","anchor":"t:state/0"},{"id":"value/0","anchor":"t:value/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"app_dir/1","anchor":"app_dir/1"},{"id":"app_dir/2","anchor":"app_dir/2"},{"id":"delete_env/3","anchor":"delete_env/3"},{"id":"ensure_all_started/2","anchor":"ensure_all_started/2"},{"id":"ensure_started/2","anchor":"ensure_started/2"},{"id":"fetch_env/2","anchor":"fetch_env/2"},{"id":"fetch_env!/2","anchor":"fetch_env!/2"},{"id":"format_error/1","anchor":"format_error/1"},{"id":"get_all_env/1","anchor":"get_all_env/1"},{"id":"get_application/1","anchor":"get_application/1"},{"id":"get_env/3","anchor":"get_env/3"},{"id":"load/1","anchor":"load/1"},{"id":"loaded_applications/0","anchor":"loaded_applications/0"},{"id":"put_all_env/2","anchor":"put_all_env/2"},{"id":"put_env/4","anchor":"put_env/4"},{"id":"spec/1","anchor":"spec/1"},{"id":"spec/2","anchor":"spec/2"},{"id":"start/2","anchor":"start/2"},{"id":"started_applications/1","anchor":"started_applications/1"},{"id":"stop/1","anchor":"stop/1"},{"id":"unload/1","anchor":"unload/1"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"config_change/3","anchor":"c:config_change/3"},{"id":"prep_stop/1","anchor":"c:prep_stop/1"},{"id":"start/2","anchor":"c:start/2"},{"id":"start_phase/3","anchor":"c:start_phase/3"},{"id":"stop/1","anchor":"c:stop/1"}]}]},{"id":"Config","title":"Config","group":"Processes & Applications","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"config/2","anchor":"config/2"},{"id":"config/3","anchor":"config/3"},{"id":"import_config/1","anchor":"import_config/1"}]}]},{"id":"Config.Provider","title":"Config.Provider","group":"Processes & Applications","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"config/0","anchor":"t:config/0"},{"id":"config_path/0","anchor":"t:config_path/0"},{"id":"state/0","anchor":"t:state/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"resolve_config_path!/1","anchor":"resolve_config_path!/1"},{"id":"validate_config_path!/1","anchor":"validate_config_path!/1"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"init/1","anchor":"c:init/1"},{"id":"load/2","anchor":"c:load/2"}]}]},{"id":"Config.Reader","title":"Config.Reader","group":"Processes & Applications","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"merge/2","anchor":"merge/2"},{"id":"read!/2","anchor":"read!/2"},{"id":"read_imports!/2","anchor":"read_imports!/2"}]}]},{"id":"DynamicSupervisor","title":"DynamicSupervisor","group":"Processes & Applications","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"init_option/0","anchor":"t:init_option/0"},{"id":"on_start_child/0","anchor":"t:on_start_child/0"},{"id":"option/0","anchor":"t:option/0"},{"id":"options/0","anchor":"t:options/0"},{"id":"strategy/0","anchor":"t:strategy/0"},{"id":"sup_flags/0","anchor":"t:sup_flags/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"count_children/1","anchor":"count_children/1"},{"id":"init/1","anchor":"init/1"},{"id":"start_child/2","anchor":"start_child/2"},{"id":"start_link/1","anchor":"start_link/1"},{"id":"start_link/3","anchor":"start_link/3"},{"id":"stop/3","anchor":"stop/3"},{"id":"terminate_child/2","anchor":"terminate_child/2"},{"id":"which_children/1","anchor":"which_children/1"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"init/1","anchor":"c:init/1"}]}]},{"id":"GenServer","title":"GenServer","group":"Processes & Applications","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"debug/0","anchor":"t:debug/0"},{"id":"from/0","anchor":"t:from/0"},{"id":"name/0","anchor":"t:name/0"},{"id":"on_start/0","anchor":"t:on_start/0"},{"id":"option/0","anchor":"t:option/0"},{"id":"options/0","anchor":"t:options/0"},{"id":"server/0","anchor":"t:server/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"abcast/3","anchor":"abcast/3"},{"id":"call/3","anchor":"call/3"},{"id":"cast/2","anchor":"cast/2"},{"id":"multi_call/4","anchor":"multi_call/4"},{"id":"reply/2","anchor":"reply/2"},{"id":"start/3","anchor":"start/3"},{"id":"start_link/3","anchor":"start_link/3"},{"id":"stop/3","anchor":"stop/3"},{"id":"whereis/1","anchor":"whereis/1"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"code_change/3","anchor":"c:code_change/3"},{"id":"format_status/2","anchor":"c:format_status/2"},{"id":"handle_call/3","anchor":"c:handle_call/3"},{"id":"handle_cast/2","anchor":"c:handle_cast/2"},{"id":"handle_continue/2","anchor":"c:handle_continue/2"},{"id":"handle_info/2","anchor":"c:handle_info/2"},{"id":"init/1","anchor":"c:init/1"},{"id":"terminate/2","anchor":"c:terminate/2"}]}]},{"id":"Node","title":"Node","group":"Processes & Applications","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"state/0","anchor":"t:state/0"},{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"alive?/0","anchor":"alive?/0"},{"id":"connect/1","anchor":"connect/1"},{"id":"disconnect/1","anchor":"disconnect/1"},{"id":"get_cookie/0","anchor":"get_cookie/0"},{"id":"list/0","anchor":"list/0"},{"id":"list/1","anchor":"list/1"},{"id":"monitor/2","anchor":"monitor/2"},{"id":"monitor/3","anchor":"monitor/3"},{"id":"ping/1","anchor":"ping/1"},{"id":"self/0","anchor":"self/0"},{"id":"set_cookie/2","anchor":"set_cookie/2"},{"id":"spawn/2","anchor":"spawn/2"},{"id":"spawn/3","anchor":"spawn/3"},{"id":"spawn/4","anchor":"spawn/4"},{"id":"spawn/5","anchor":"spawn/5"},{"id":"spawn_link/2","anchor":"spawn_link/2"},{"id":"spawn_link/4","anchor":"spawn_link/4"},{"id":"start/3","anchor":"start/3"},{"id":"stop/0","anchor":"stop/0"}]}]},{"id":"Process","title":"Process","group":"Processes & Applications","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"dest/0","anchor":"t:dest/0"},{"id":"spawn_opt/0","anchor":"t:spawn_opt/0"},{"id":"spawn_opts/0","anchor":"t:spawn_opts/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"alive?/1","anchor":"alive?/1"},{"id":"cancel_timer/2","anchor":"cancel_timer/2"},{"id":"delete/1","anchor":"delete/1"},{"id":"demonitor/2","anchor":"demonitor/2"},{"id":"exit/2","anchor":"exit/2"},{"id":"flag/2","anchor":"flag/2"},{"id":"flag/3","anchor":"flag/3"},{"id":"get/0","anchor":"get/0"},{"id":"get/2","anchor":"get/2"},{"id":"get_keys/0","anchor":"get_keys/0"},{"id":"get_keys/1","anchor":"get_keys/1"},{"id":"group_leader/0","anchor":"group_leader/0"},{"id":"group_leader/2","anchor":"group_leader/2"},{"id":"hibernate/3","anchor":"hibernate/3"},{"id":"info/1","anchor":"info/1"},{"id":"info/2","anchor":"info/2"},{"id":"link/1","anchor":"link/1"},{"id":"list/0","anchor":"list/0"},{"id":"monitor/1","anchor":"monitor/1"},{"id":"put/2","anchor":"put/2"},{"id":"read_timer/1","anchor":"read_timer/1"},{"id":"register/2","anchor":"register/2"},{"id":"registered/0","anchor":"registered/0"},{"id":"send/3","anchor":"send/3"},{"id":"send_after/4","anchor":"send_after/4"},{"id":"sleep/1","anchor":"sleep/1"},{"id":"spawn/2","anchor":"spawn/2"},{"id":"spawn/4","anchor":"spawn/4"},{"id":"unlink/1","anchor":"unlink/1"},{"id":"unregister/1","anchor":"unregister/1"},{"id":"whereis/1","anchor":"whereis/1"}]}]},{"id":"Registry","title":"Registry","group":"Processes & Applications","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"body/0","anchor":"t:body/0"},{"id":"guard/0","anchor":"t:guard/0"},{"id":"guards/0","anchor":"t:guards/0"},{"id":"key/0","anchor":"t:key/0"},{"id":"keys/0","anchor":"t:keys/0"},{"id":"match_pattern/0","anchor":"t:match_pattern/0"},{"id":"meta_key/0","anchor":"t:meta_key/0"},{"id":"meta_value/0","anchor":"t:meta_value/0"},{"id":"registry/0","anchor":"t:registry/0"},{"id":"spec/0","anchor":"t:spec/0"},{"id":"value/0","anchor":"t:value/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"count/1","anchor":"count/1"},{"id":"count_match/4","anchor":"count_match/4"},{"id":"dispatch/4","anchor":"dispatch/4"},{"id":"keys/2","anchor":"keys/2"},{"id":"lookup/2","anchor":"lookup/2"},{"id":"match/4","anchor":"match/4"},{"id":"meta/2","anchor":"meta/2"},{"id":"put_meta/3","anchor":"put_meta/3"},{"id":"register/3","anchor":"register/3"},{"id":"select/2","anchor":"select/2"},{"id":"start_link/1","anchor":"start_link/1"},{"id":"unregister/2","anchor":"unregister/2"},{"id":"unregister_match/4","anchor":"unregister_match/4"},{"id":"update_value/3","anchor":"update_value/3"}]}]},{"id":"Supervisor","title":"Supervisor","group":"Processes & Applications","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"child/0","anchor":"t:child/0"},{"id":"child_spec/0","anchor":"t:child_spec/0"},{"id":"init_option/0","anchor":"t:init_option/0"},{"id":"name/0","anchor":"t:name/0"},{"id":"on_start/0","anchor":"t:on_start/0"},{"id":"on_start_child/0","anchor":"t:on_start_child/0"},{"id":"option/0","anchor":"t:option/0"},{"id":"options/0","anchor":"t:options/0"},{"id":"strategy/0","anchor":"t:strategy/0"},{"id":"supervisor/0","anchor":"t:supervisor/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"child_spec/2","anchor":"child_spec/2"},{"id":"count_children/1","anchor":"count_children/1"},{"id":"delete_child/2","anchor":"delete_child/2"},{"id":"init/2","anchor":"init/2"},{"id":"restart_child/2","anchor":"restart_child/2"},{"id":"start_child/2","anchor":"start_child/2"},{"id":"start_link/2","anchor":"start_link/2"},{"id":"start_link/3","anchor":"start_link/3"},{"id":"stop/3","anchor":"stop/3"},{"id":"terminate_child/2","anchor":"terminate_child/2"},{"id":"which_children/1","anchor":"which_children/1"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"init/1","anchor":"c:init/1"}]}]},{"id":"Task","title":"Task","group":"Processes & Applications","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"__struct__/0","anchor":"__struct__/0"},{"id":"async/1","anchor":"async/1"},{"id":"async/3","anchor":"async/3"},{"id":"async_stream/3","anchor":"async_stream/3"},{"id":"async_stream/5","anchor":"async_stream/5"},{"id":"await/2","anchor":"await/2"},{"id":"child_spec/1","anchor":"child_spec/1"},{"id":"shutdown/2","anchor":"shutdown/2"},{"id":"start/1","anchor":"start/1"},{"id":"start/3","anchor":"start/3"},{"id":"start_link/1","anchor":"start_link/1"},{"id":"start_link/3","anchor":"start_link/3"},{"id":"yield/2","anchor":"yield/2"},{"id":"yield_many/2","anchor":"yield_many/2"}]}]},{"id":"Task.Supervisor","title":"Task.Supervisor","group":"Processes & Applications","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"option/0","anchor":"t:option/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"async/3","anchor":"async/3"},{"id":"async/5","anchor":"async/5"},{"id":"async_nolink/3","anchor":"async_nolink/3"},{"id":"async_nolink/5","anchor":"async_nolink/5"},{"id":"async_stream/4","anchor":"async_stream/4"},{"id":"async_stream/6","anchor":"async_stream/6"},{"id":"async_stream_nolink/4","anchor":"async_stream_nolink/4"},{"id":"async_stream_nolink/6","anchor":"async_stream_nolink/6"},{"id":"children/1","anchor":"children/1"},{"id":"start_child/3","anchor":"start_child/3"},{"id":"start_child/5","anchor":"start_child/5"},{"id":"start_link/1","anchor":"start_link/1"},{"id":"terminate_child/2","anchor":"terminate_child/2"}]}]},{"id":"Collectable","title":"Collectable","group":"Protocols","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"command/0","anchor":"t:command/0"},{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"into/1","anchor":"into/1"}]}]},{"id":"Enumerable","title":"Enumerable","group":"Protocols","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"acc/0","anchor":"t:acc/0"},{"id":"continuation/0","anchor":"t:continuation/0"},{"id":"reducer/0","anchor":"t:reducer/0"},{"id":"result/0","anchor":"t:result/0"},{"id":"slicing_fun/0","anchor":"t:slicing_fun/0"},{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"count/1","anchor":"count/1"},{"id":"member?/2","anchor":"member?/2"},{"id":"reduce/3","anchor":"reduce/3"},{"id":"slice/1","anchor":"slice/1"}]}]},{"id":"Inspect","title":"Inspect","group":"Protocols","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"inspect/2","anchor":"inspect/2"}]}]},{"id":"Inspect.Algebra","title":"Inspect.Algebra","group":"Protocols","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"guards","name":"Guards","nodes":[{"id":"is_doc/1","anchor":"is_doc/1"}]},{"key":"functions","name":"Functions","nodes":[{"id":"break/1","anchor":"break/1"},{"id":"collapse_lines/1","anchor":"collapse_lines/1"},{"id":"color/3","anchor":"color/3"},{"id":"concat/1","anchor":"concat/1"},{"id":"concat/2","anchor":"concat/2"},{"id":"container_doc/6","anchor":"container_doc/6"},{"id":"empty/0","anchor":"empty/0"},{"id":"flex_break/1","anchor":"flex_break/1"},{"id":"flex_glue/3","anchor":"flex_glue/3"},{"id":"fold_doc/2","anchor":"fold_doc/2"},{"id":"force_unfit/1","anchor":"force_unfit/1"},{"id":"format/2","anchor":"format/2"},{"id":"glue/3","anchor":"glue/3"},{"id":"group/2","anchor":"group/2"},{"id":"line/0","anchor":"line/0"},{"id":"line/2","anchor":"line/2"},{"id":"nest/3","anchor":"nest/3"},{"id":"next_break_fits/2","anchor":"next_break_fits/2"},{"id":"space/2","anchor":"space/2"},{"id":"string/1","anchor":"string/1"},{"id":"to_doc/2","anchor":"to_doc/2"}]}]},{"id":"Inspect.Opts","title":"Inspect.Opts","group":"Protocols","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"color_key/0","anchor":"t:color_key/0"},{"id":"t/0","anchor":"t:t/0"}]}]},{"id":"List.Chars","title":"List.Chars","group":"Protocols","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"to_charlist/1","anchor":"to_charlist/1"}]}]},{"id":"Protocol","title":"Protocol","group":"Protocols","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"assert_impl!/2","anchor":"assert_impl!/2"},{"id":"assert_protocol!/1","anchor":"assert_protocol!/1"},{"id":"consolidate/2","anchor":"consolidate/2"},{"id":"consolidated?/1","anchor":"consolidated?/1"},{"id":"derive/3","anchor":"derive/3"},{"id":"extract_impls/2","anchor":"extract_impls/2"},{"id":"extract_protocols/1","anchor":"extract_protocols/1"}]}]},{"id":"String.Chars","title":"String.Chars","group":"Protocols","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"to_string/1","anchor":"to_string/1"}]}]},{"id":"Code","title":"Code","group":"Code & Macros","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"append_path/1","anchor":"append_path/1"},{"id":"available_compiler_options/0","anchor":"available_compiler_options/0"},{"id":"compile_file/2","anchor":"compile_file/2"},{"id":"compile_quoted/2","anchor":"compile_quoted/2"},{"id":"compile_string/2","anchor":"compile_string/2"},{"id":"compiler_options/0","anchor":"compiler_options/0"},{"id":"compiler_options/1","anchor":"compiler_options/1"},{"id":"delete_path/1","anchor":"delete_path/1"},{"id":"ensure_compiled/1","anchor":"ensure_compiled/1"},{"id":"ensure_compiled?/1","anchor":"ensure_compiled?/1"},{"id":"ensure_loaded/1","anchor":"ensure_loaded/1"},{"id":"ensure_loaded?/1","anchor":"ensure_loaded?/1"},{"id":"eval_file/2","anchor":"eval_file/2"},{"id":"eval_quoted/3","anchor":"eval_quoted/3"},{"id":"eval_string/3","anchor":"eval_string/3"},{"id":"fetch_docs/1","anchor":"fetch_docs/1"},{"id":"format_file!/2","anchor":"format_file!/2"},{"id":"format_string!/2","anchor":"format_string!/2"},{"id":"get_docs/2","anchor":"get_docs/2"},{"id":"prepend_path/1","anchor":"prepend_path/1"},{"id":"purge_compiler_modules/0","anchor":"purge_compiler_modules/0"},{"id":"require_file/2","anchor":"require_file/2"},{"id":"required_files/0","anchor":"required_files/0"},{"id":"string_to_quoted/2","anchor":"string_to_quoted/2"},{"id":"string_to_quoted!/2","anchor":"string_to_quoted!/2"},{"id":"unrequire_files/1","anchor":"unrequire_files/1"}]}]},{"id":"Kernel.ParallelCompiler","title":"Kernel.ParallelCompiler","group":"Code & Macros","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"async/1","anchor":"async/1"},{"id":"compile/2","anchor":"compile/2"},{"id":"compile_to_path/3","anchor":"compile_to_path/3"},{"id":"require/2","anchor":"require/2"}]}]},{"id":"Macro","title":"Macro","group":"Code & Macros","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"expr/0","anchor":"t:expr/0"},{"id":"literal/0","anchor":"t:literal/0"},{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"camelize/1","anchor":"camelize/1"},{"id":"decompose_call/1","anchor":"decompose_call/1"},{"id":"escape/2","anchor":"escape/2"},{"id":"expand/2","anchor":"expand/2"},{"id":"expand_once/2","anchor":"expand_once/2"},{"id":"generate_arguments/2","anchor":"generate_arguments/2"},{"id":"operator?/2","anchor":"operator?/2"},{"id":"pipe/3","anchor":"pipe/3"},{"id":"postwalk/2","anchor":"postwalk/2"},{"id":"postwalk/3","anchor":"postwalk/3"},{"id":"prewalk/2","anchor":"prewalk/2"},{"id":"prewalk/3","anchor":"prewalk/3"},{"id":"quoted_literal?/1","anchor":"quoted_literal?/1"},{"id":"special_form?/2","anchor":"special_form?/2"},{"id":"struct!/2","anchor":"struct!/2"},{"id":"to_string/2","anchor":"to_string/2"},{"id":"traverse/4","anchor":"traverse/4"},{"id":"underscore/1","anchor":"underscore/1"},{"id":"unescape_string/1","anchor":"unescape_string/1"},{"id":"unescape_string/2","anchor":"unescape_string/2"},{"id":"unpipe/1","anchor":"unpipe/1"},{"id":"update_meta/2","anchor":"update_meta/2"},{"id":"validate/1","anchor":"validate/1"},{"id":"var/2","anchor":"var/2"}]}]},{"id":"Macro.Env","title":"Macro.Env","group":"Code & Macros","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"aliases/0","anchor":"t:aliases/0"},{"id":"context/0","anchor":"t:context/0"},{"id":"context_modules/0","anchor":"t:context_modules/0"},{"id":"file/0","anchor":"t:file/0"},{"id":"functions/0","anchor":"t:functions/0"},{"id":"lexical_tracker/0","anchor":"t:lexical_tracker/0"},{"id":"line/0","anchor":"t:line/0"},{"id":"macro_aliases/0","anchor":"t:macro_aliases/0"},{"id":"macros/0","anchor":"t:macros/0"},{"id":"name_arity/0","anchor":"t:name_arity/0"},{"id":"requires/0","anchor":"t:requires/0"},{"id":"t/0","anchor":"t:t/0"},{"id":"variable/0","anchor":"t:variable/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"has_var?/2","anchor":"has_var?/2"},{"id":"in_guard?/1","anchor":"in_guard?/1"},{"id":"in_match?/1","anchor":"in_match?/1"},{"id":"location/1","anchor":"location/1"},{"id":"stacktrace/1","anchor":"stacktrace/1"},{"id":"to_match/1","anchor":"to_match/1"},{"id":"vars/1","anchor":"vars/1"}]}]},{"id":"Behaviour","title":"Behaviour","group":"Deprecated","nodeGroups":[{"key":"functions","name":"Functions","nodes":[{"id":"defcallback/1","anchor":"defcallback/1"},{"id":"defmacrocallback/1","anchor":"defmacrocallback/1"}]}]},{"id":"Dict","title":"Dict","group":"Deprecated","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"key/0","anchor":"t:key/0"},{"id":"t/0","anchor":"t:t/0"},{"id":"value/0","anchor":"t:value/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"delete/2","anchor":"delete/2"},{"id":"drop/2","anchor":"drop/2"},{"id":"empty/1","anchor":"empty/1"},{"id":"equal?/2","anchor":"equal?/2"},{"id":"fetch/2","anchor":"fetch/2"},{"id":"fetch!/2","anchor":"fetch!/2"},{"id":"get/3","anchor":"get/3"},{"id":"get_and_update/3","anchor":"get_and_update/3"},{"id":"get_lazy/3","anchor":"get_lazy/3"},{"id":"has_key?/2","anchor":"has_key?/2"},{"id":"keys/1","anchor":"keys/1"},{"id":"merge/2","anchor":"merge/2"},{"id":"merge/3","anchor":"merge/3"},{"id":"pop/3","anchor":"pop/3"},{"id":"pop_lazy/3","anchor":"pop_lazy/3"},{"id":"put/3","anchor":"put/3"},{"id":"put_new/3","anchor":"put_new/3"},{"id":"put_new_lazy/3","anchor":"put_new_lazy/3"},{"id":"size/1","anchor":"size/1"},{"id":"split/2","anchor":"split/2"},{"id":"take/2","anchor":"take/2"},{"id":"to_list/1","anchor":"to_list/1"},{"id":"update/4","anchor":"update/4"},{"id":"update!/3","anchor":"update!/3"},{"id":"values/1","anchor":"values/1"}]}]},{"id":"GenEvent","title":"GenEvent","group":"Deprecated","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"handler/0","anchor":"t:handler/0"},{"id":"manager/0","anchor":"t:manager/0"},{"id":"name/0","anchor":"t:name/0"},{"id":"on_start/0","anchor":"t:on_start/0"},{"id":"options/0","anchor":"t:options/0"}]},{"key":"callbacks","name":"Callbacks","nodes":[{"id":"code_change/3","anchor":"c:code_change/3"},{"id":"handle_call/2","anchor":"c:handle_call/2"},{"id":"handle_event/2","anchor":"c:handle_event/2"},{"id":"handle_info/2","anchor":"c:handle_info/2"},{"id":"init/1","anchor":"c:init/1"},{"id":"terminate/2","anchor":"c:terminate/2"}]}]},{"id":"HashDict","title":"HashDict","group":"Deprecated","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"delete/2","anchor":"delete/2"},{"id":"drop/2","anchor":"drop/2"},{"id":"equal?/2","anchor":"equal?/2"},{"id":"fetch/2","anchor":"fetch/2"},{"id":"fetch!/2","anchor":"fetch!/2"},{"id":"get/3","anchor":"get/3"},{"id":"get_and_update/3","anchor":"get_and_update/3"},{"id":"get_lazy/3","anchor":"get_lazy/3"},{"id":"has_key?/2","anchor":"has_key?/2"},{"id":"keys/1","anchor":"keys/1"},{"id":"merge/3","anchor":"merge/3"},{"id":"new/0","anchor":"new/0"},{"id":"pop/3","anchor":"pop/3"},{"id":"pop_lazy/3","anchor":"pop_lazy/3"},{"id":"put/3","anchor":"put/3"},{"id":"put_new/3","anchor":"put_new/3"},{"id":"put_new_lazy/3","anchor":"put_new_lazy/3"},{"id":"size/1","anchor":"size/1"},{"id":"split/2","anchor":"split/2"},{"id":"take/2","anchor":"take/2"},{"id":"to_list/1","anchor":"to_list/1"},{"id":"update/4","anchor":"update/4"},{"id":"update!/3","anchor":"update!/3"},{"id":"values/1","anchor":"values/1"}]}]},{"id":"HashSet","title":"HashSet","group":"Deprecated","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"delete/2","anchor":"delete/2"},{"id":"difference/2","anchor":"difference/2"},{"id":"disjoint?/2","anchor":"disjoint?/2"},{"id":"equal?/2","anchor":"equal?/2"},{"id":"intersection/2","anchor":"intersection/2"},{"id":"member?/2","anchor":"member?/2"},{"id":"new/0","anchor":"new/0"},{"id":"put/2","anchor":"put/2"},{"id":"size/1","anchor":"size/1"},{"id":"subset?/2","anchor":"subset?/2"},{"id":"to_list/1","anchor":"to_list/1"},{"id":"union/2","anchor":"union/2"}]}]},{"id":"Set","title":"Set","group":"Deprecated","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"t/0","anchor":"t:t/0"},{"id":"value/0","anchor":"t:value/0"},{"id":"values/0","anchor":"t:values/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"delete/2","anchor":"delete/2"},{"id":"difference/2","anchor":"difference/2"},{"id":"disjoint?/2","anchor":"disjoint?/2"},{"id":"empty/1","anchor":"empty/1"},{"id":"equal?/2","anchor":"equal?/2"},{"id":"intersection/2","anchor":"intersection/2"},{"id":"member?/2","anchor":"member?/2"},{"id":"put/2","anchor":"put/2"},{"id":"size/1","anchor":"size/1"},{"id":"subset?/2","anchor":"subset?/2"},{"id":"to_list/1","anchor":"to_list/1"},{"id":"union/2","anchor":"union/2"}]}]},{"id":"Supervisor.Spec","title":"Supervisor.Spec","group":"Deprecated","nodeGroups":[{"key":"types","name":"Types","nodes":[{"id":"child_id/0","anchor":"t:child_id/0"},{"id":"modules/0","anchor":"t:modules/0"},{"id":"restart/0","anchor":"t:restart/0"},{"id":"shutdown/0","anchor":"t:shutdown/0"},{"id":"spec/0","anchor":"t:spec/0"},{"id":"strategy/0","anchor":"t:strategy/0"},{"id":"worker/0","anchor":"t:worker/0"}]},{"key":"functions","name":"Functions","nodes":[{"id":"supervise/2","anchor":"supervise/2"},{"id":"supervisor/3","anchor":"supervisor/3"},{"id":"worker/3","anchor":"worker/3"}]}]}],"tasks":[]}